      SUBROUTINE ASS2D(IA,JA,AN,AD,N,B,X,Q,EPS,ITMAX,IFLAG)
C
C            -
C         AX=B   - 
C      A  ,    RR(LU)U,  -
C     ,       ,  
C     -. 
C
      INTEGER IA,JA,N,ITMAX,IFLAG
      DOUBLE PRECISION B,X,Q,AN,AD,EPS
      DIMENSION IA(1),JA(1),AN(1),AD(N),B(N),X(N)
C
C  IA, JA, AN -      -
C                 A   RR(LU)U;
C       
C          AD -     N, 
C                N,       
C               A; ,      
C                  ;
C
C           N -    A (: );
C  
C           B -         
C                N,     ;
C
C           X -      
C                N,      - 
C                   ;
C
C           Q -    (: 
C               );
C
C         EPS -   ,   
C                ;
C
C       ITMAX -      
C               -;
C
C       IFLAG -  ,      -
C                 :
C
C                IFLAG = 0 -      -
C                            ;
C                IFLAG = 1 -      
C                                -
C                            
C 
      INTEGER I,ITER,IEND,IAA,IAB,J,L
      DOUBLE PRECISION U
C
C        ASS2RR     ITER, 
C           -
C       ,  IFLAG = 0.  IFLAG = 1,
C      ITER = ITMAX
C
      COMMON/ASS2RR/ITER
      ITER=0
      IFLAG=0
C
C         
C
      DO 5 I=1,N
    5 X(I)=B(I)/AD(I)
C
C        20,      -
C         ITMAX
C
   10 IF(ITER.LT.ITMAX) GO TO 20
      IFLAG=1
      GO TO 50
   20 ITER=ITER+1
C
C           
C
      IEND=0
      DO 40 I=1,N
      IAA=IA(I)
      IAB=IA(I+1)-1
      IF(IAB.LT.IAA) GO TO 40
C
C            I-
C      ,   I  A   
C        
C
      U=B(I)
      DO 30 J=IAA,IAB
      L=JA(J)
   30 U=U-AN(J)*X(L)
      U=U/AD(I)-X(I)
C
C     ,    
C
      IF(DABS(U).GT.EPS) IEND=1
C
C        
C
      X(I)=X(I)+Q*U
   40 CONTINUE
      IF(IEND.EQ.1) GO TO 10
  50  RETURN
      END
